var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var aggregate_exports = {};
__export(aggregate_exports, {
  default: () => aggregate_default
});
module.exports = __toCommonJS(aggregate_exports);
var import_database = require("@nocobase/database");
var import_constants = require("../constants");
const aggregators = {
  count: "count",
  sum: "sum",
  avg: "avg",
  min: "min",
  max: "max"
};
var aggregate_default = {
  async run(node, input, processor) {
    const { aggregator, associated, collection, association = {}, params = {} } = node.config;
    const options = processor.getParsedValue(params, node.id);
    const { database } = node.constructor;
    const repo = associated ? database.getRepository(
      `${association == null ? void 0 : association.associatedCollection}.${association.name}`,
      processor.getParsedValue(association == null ? void 0 : association.associatedKey, node.id)
    ) : database.getRepository(collection);
    if (!options.dataType && aggregator === "avg") {
      options.dataType = import_database.DataTypes.DOUBLE;
    }
    const result = await repo.aggregate({
      ...options,
      method: aggregators[aggregator],
      transaction: processor.transaction
    });
    return {
      result: options.dataType === import_database.DataTypes.DOUBLE ? Number(result) : result,
      status: import_constants.JOB_STATUS.RESOLVED
    };
  }
};
