var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var calculation_exports = {};
__export(calculation_exports, {
  default: () => calculation_default
});
module.exports = __toCommonJS(calculation_exports);
var import_evaluators = require("@nocobase/evaluators");
var import_utils = require("@nocobase/utils");
var import_constants = require("../constants");
var calculation_default = {
  async run(node, prevJob, processor) {
    const { dynamic = false } = node.config || {};
    let { engine = "math.js", expression = "" } = node.config;
    let scope = processor.getScope(node.id);
    if (dynamic) {
      const parsed = (0, import_utils.parse)(dynamic)(scope) ?? {};
      engine = parsed.engine;
      expression = parsed.expression;
      scope = (0, import_utils.parse)(node.config.scope ?? "")(scope) ?? {};
    }
    const evaluator = import_evaluators.evaluators.get(engine);
    try {
      const result = evaluator && expression ? evaluator(expression, scope) : null;
      return {
        result,
        status: import_constants.JOB_STATUS.RESOLVED
      };
    } catch (e) {
      return {
        result: e.toString(),
        status: import_constants.JOB_STATUS.ERROR
      };
    }
  }
};
