var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var manual_exports = {};
__export(manual_exports, {
  default: () => manual_default
});
module.exports = __toCommonJS(manual_exports);
var import_actions = __toESM(require("@nocobase/actions"));
var import_utils = require("@nocobase/utils");
var import_constants = require("../../constants");
var import_jobs = __toESM(require("./collecions/jobs"));
var import_users = __toESM(require("./collecions/users"));
var import_users_jobs = __toESM(require("./collecions/users_jobs"));
var import_actions2 = require("./actions");
var import_forms = __toESM(require("./forms"));
const MULTIPLE_ASSIGNED_MODE = {
  SINGLE: Symbol("single"),
  ALL: Symbol("all"),
  ANY: Symbol("any"),
  ALL_PERCENTAGE: Symbol("all percentage"),
  ANY_PERCENTAGE: Symbol("any percentage")
};
const Modes = {
  [MULTIPLE_ASSIGNED_MODE.SINGLE]: {
    getStatus(distribution, assignees) {
      const done = distribution.find((item) => item.status !== import_constants.JOB_STATUS.PENDING && item.count > 0);
      return done ? done.status : null;
    }
  },
  [MULTIPLE_ASSIGNED_MODE.ALL]: {
    getStatus(distribution, assignees) {
      const resolved = distribution.find((item) => item.status === import_constants.JOB_STATUS.RESOLVED);
      if (resolved && resolved.count === assignees.length) {
        return import_constants.JOB_STATUS.RESOLVED;
      }
      const rejected = distribution.find((item) => item.status < import_constants.JOB_STATUS.PENDING);
      if (rejected && rejected.count) {
        return rejected.status;
      }
      return null;
    }
  },
  [MULTIPLE_ASSIGNED_MODE.ANY]: {
    getStatus(distribution, assignees) {
      const resolved = distribution.find((item) => item.status === import_constants.JOB_STATUS.RESOLVED);
      if (resolved && resolved.count) {
        return import_constants.JOB_STATUS.RESOLVED;
      }
      const rejectedCount = distribution.reduce(
        (count, item) => item.status < import_constants.JOB_STATUS.PENDING ? count + item.count : count,
        0
      );
      if (rejectedCount === assignees.length) {
        return import_constants.JOB_STATUS.REJECTED;
      }
      return null;
    }
  }
};
function getMode(mode) {
  switch (true) {
    case mode === 1:
      return Modes[MULTIPLE_ASSIGNED_MODE.ALL];
    case mode === -1:
      return Modes[MULTIPLE_ASSIGNED_MODE.ANY];
    case mode > 0:
      return Modes[MULTIPLE_ASSIGNED_MODE.ALL_PERCENTAGE];
    case mode < 0:
      return Modes[MULTIPLE_ASSIGNED_MODE.ANY_PERCENTAGE];
    default:
      return Modes[MULTIPLE_ASSIGNED_MODE.SINGLE];
  }
}
class manual_default {
  constructor(plugin) {
    this.plugin = plugin;
    plugin.db.collection(import_users_jobs.default);
    plugin.db.extendCollection(import_users.default);
    plugin.db.extendCollection(import_jobs.default);
    plugin.app.resource({
      name: "users_jobs",
      actions: {
        list: {
          filter: {
            $or: [
              {
                "workflow.enabled": true
              },
              {
                "workflow.enabled": false,
                status: {
                  $ne: import_constants.JOB_STATUS.PENDING
                }
              }
            ]
          },
          handler: import_actions.default.list
        },
        submit: import_actions2.submit
      }
    });
    (0, import_forms.default)(this);
  }
  formTypes = new import_utils.Registry();
  async run(node, prevJob, processor) {
    const { mode, ...config } = node.config;
    const assignees = [...new Set(processor.getParsedValue(config.assignees, node.id) || [])];
    const job = await processor.saveJob({
      status: import_constants.JOB_STATUS.PENDING,
      result: mode ? [] : null,
      nodeId: node.id,
      upstreamId: (prevJob == null ? void 0 : prevJob.id) ?? null
    });
    const UserJobModel = processor.options.plugin.db.getModel("users_jobs");
    await UserJobModel.bulkCreate(
      assignees.map((userId) => ({
        userId,
        jobId: job.id,
        nodeId: node.id,
        executionId: job.executionId,
        workflowId: node.workflowId,
        status: import_constants.JOB_STATUS.PENDING
      })),
      {
        transaction: processor.transaction
      }
    );
    return job;
  }
  async resume(node, job, processor) {
    var _a;
    const { assignees = [], mode } = node.config;
    const UserJobModel = processor.options.plugin.db.getModel("users_jobs");
    const distribution = await UserJobModel.count({
      where: {
        jobId: job.id
      },
      group: ["status"],
      transaction: processor.transaction
    });
    const submitted = distribution.reduce(
      (count, item) => item.status !== import_constants.JOB_STATUS.PENDING ? count + item.count : count,
      0
    );
    const status = job.status || (getMode(mode).getStatus(distribution, assignees) ?? import_constants.JOB_STATUS.PENDING);
    const result = mode ? (submitted || 0) / assignees.length : ((_a = job.latestUserJob) == null ? void 0 : _a.result) ?? job.result;
    processor.logger.debug(`manual resume job and next status: ${status}`);
    job.set({
      status,
      result
    });
    return job;
  }
}
