import { AxiosRequestConfig } from 'axios';
import { Instruction } from './index';
import Processor from '../Processor';
import type { FlowNodeModel } from '../types';
export interface Header {
    name: string;
    value: string;
}
export type RequestConfig = Pick<AxiosRequestConfig, 'url' | 'method' | 'params' | 'data' | 'timeout'> & {
    headers: Array<Header>;
    ignoreFail: boolean;
};
export default class implements Instruction {
    plugin: any;
    constructor(plugin: any);
    run(node: FlowNodeModel, prevJob: any, processor: Processor): Promise<any>;
    resume(node: FlowNodeModel, job: any, processor: Processor): Promise<any>;
}
