var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var request_exports = {};
__export(request_exports, {
  default: () => request_default
});
module.exports = __toCommonJS(request_exports);
var import_axios = __toESM(require("axios"));
var import_constants = require("../constants");
async function request(config) {
  const { url, method = "POST", data, timeout = 5e3 } = config;
  const headers = (config.headers ?? []).reduce((result, header) => {
    if (header.name.toLowerCase() === "content-type") {
      return result;
    }
    return Object.assign(result, { [header.name]: header.value });
  }, {});
  const params = (config.params ?? []).reduce(
    (result, param) => Object.assign(result, { [param.name]: param.value }),
    {}
  );
  headers["Content-Type"] = "application/json";
  return import_axios.default.request({
    url,
    method,
    headers,
    params,
    data,
    timeout
  });
}
class request_default {
  constructor(plugin) {
    this.plugin = plugin;
  }
  async run(node, prevJob, processor) {
    const job = await processor.saveJob({
      status: import_constants.JOB_STATUS.PENDING,
      nodeId: node.id,
      upstreamId: (prevJob == null ? void 0 : prevJob.id) ?? null
    });
    const config = processor.getParsedValue(node.config, node.id);
    request(config).then((response) => {
      job.set({
        status: import_constants.JOB_STATUS.RESOLVED,
        result: response.data
      });
    }).catch((error) => {
      job.set({
        status: import_constants.JOB_STATUS.FAILED,
        result: error.isAxiosError ? error.toJSON() : error.message
      });
    }).finally(() => {
      processor.logger.info(`request (#${node.id}) response received, status: ${job.get("status")}`);
      this.plugin.resume(job);
    });
    processor.logger.info(`request (#${node.id}) sent to "${config.url}", waiting for response...`);
    return processor.exit();
  }
  async resume(node, job, processor) {
    const { ignoreFail } = node.config;
    if (ignoreFail) {
      job.set("status", import_constants.JOB_STATUS.RESOLVED);
    }
    return job;
  }
}
